package net.ccbluex.liquidbounce.features.module.modules.misc

import io.netty.util.internal.ConcurrentSet
import net.ccbluex.liquidbounce.event.EventTarget
import net.ccbluex.liquidbounce.event.Render3DEvent
import net.ccbluex.liquidbounce.event.UpdateEvent
import net.ccbluex.liquidbounce.features.module.Module
import net.ccbluex.liquidbounce.features.module.ModuleCategory
import net.ccbluex.liquidbounce.utils.ClientUtils
import net.ccbluex.liquidbounce.utils.RotationUtils
import net.ccbluex.liquidbounce.utils.extensions.eyes
import net.ccbluex.liquidbounce.utils.extensions.getVec
import net.ccbluex.liquidbounce.utils.extensions.multiply
import net.ccbluex.liquidbounce.utils.extensions.toAxisAlignedBB
import net.ccbluex.liquidbounce.utils.render.RenderUtils
import net.ccbluex.liquidbounce.value.BoolValue
import net.ccbluex.liquidbounce.value.FloatValue
import net.ccbluex.liquidbounce.value.IntegerValue
import net.minecraft.block.material.Material
import net.minecraft.entity.projectile.EntityLargeFireball
import net.minecraft.item.ItemFireball
import net.minecraft.network.play.client.C08PacketPlayerBlockPlacement
import net.minecraft.network.play.client.C09PacketHeldItemChange
import net.minecraft.util.BlockPos
import net.minecraft.util.Vec3
import java.awt.Color
import kotlin.math.abs
import kotlin.math.sqrt

/**
 * @author fr3
 */
object AntiAir : Module("AntiAir", ModuleCategory.MISC) {
    private val poseses = HashMap<EntityLargeFireball, ArrayList<Vec3>>()
    private val appear = ConcurrentSet<EntityLargeFireball>()
    private val readyFireballs = ConcurrentSet<EntityLargeFireball>()
    private val blockMap = HashMap<EntityLargeFireball, BlockPos>()

    private var catchVec: Vec3? = null
    private var toBeAnti: EntityLargeFireball? = null

    private var doStep1 = false
    private var doStep2 = false

    // VALUES
    private val delayValue = IntegerValue("delay", 0, 0, 1000)
    private val yOffsetValue = FloatValue("Y-Offset", 0.1F, 0f..1f)
    private val targetFireballThatAreGettingFurtherValue = BoolValue("TargetFireballThatAreGettingFurther", false)
    private val targetFireballThatWontHitAnythingValue = BoolValue("TargetFireballThatWontHitAnything", false)
    private val targetFireballThatAreOutOfHitRangeValue = BoolValue("TargetFireballThatAreOutOfHitRange", false)
    private val hitRangeValue = FloatValue("HitRange", 30f, 6f..200f)
    private val rangeValue = IntegerValue("Range", 200, 6, 500)
    private fun second() = rangeValue.get() / 17.0

    private const val TICK = 0.05

    override fun onEnable() {
        // TODO 提示没有开启ServerPing
        appear.clear()
        readyFireballs.clear()
        poseses.clear()
        blockMap.clear()


        catchVec = null
        toBeAnti = null

        doStep1 = false
        doStep2 = false

        // TODO 完善逻辑， 清晰代码思路
    }

    @EventTarget
    fun onUpdate(event: UpdateEvent) {
        val list = mc.theWorld.getLoadedEntityList().filterIsInstance<EntityLargeFireball>().toList()

        for (fireball in list) {
            if (!readyFireballs.contains(fireball))
            {
                if (!appear.contains(fireball))
                {
                    // 此处不能删去，否则算法会故障，因为刚出现时motion是0
                    appear.add(fireball)
                    return
                }
                else
                {
                    readyFireballs.add(fireball)
                    val distance = mc.thePlayer.getDistanceToEntity(fireball)
                    if (distance > 5 && distance < rangeValue.get())
                    {
                        tryToCatchFireball(fireball)
                    }
                }
            }
        }

        // 清理已经死亡的火球
        for (fireball in readyFireballs)
            if (!mc.theWorld.getLoadedEntityList().contains(fireball) || fireball.isDead)
            {
                appear.remove(fireball)
                readyFireballs.remove(fireball)
                poseses.remove(fireball)
                blockMap.remove(fireball)
            }

        if (!mc.theWorld.getLoadedEntityList().contains(toBeAnti))
        {
            catchVec = null
            toBeAnti = null
            doStep1 = false
            doStep2 = false // To be confirmed
        }

        if (doStep2) {
            doStep2 = false

            val slot = findFireballInHotbar()
            if (slot != -1)
            {
                val itemStack = mc.thePlayer.inventoryContainer.getSlot(slot).stack

                if (itemStack != null) {
                    mc.netHandler.addToSendQueue(C08PacketPlayerBlockPlacement(itemStack))
                    mc.netHandler.addToSendQueue(C09PacketHeldItemChange(mc.thePlayer.inventory.currentItem))
                }
                else
                {
                    ClientUtils.displayChatMessage("错误!#2")
                }
            }
            else
            {
                ClientUtils.displayChatMessage("物品栏里面没有火球！")
            }

            catchVec = null
        }

        // 上下if顺序不能换！

        if (doStep1)
        {
            val finalRotation = RotationUtils.toRotation(catchVec!!, false) // TODO confirm predict=true? has to do with pre/post's time

            RotationUtils.setTargetRotation(finalRotation, 5, resetSpeed = Pair(70f, 100f)) // ?

            doStep2 = true
            ClientUtils.displayChatMessage("尝试拦截")
            doStep1 = false

            val slot = findFireballInHotbar()
            if (slot != -1)
            {
                val itemStack = mc.thePlayer.inventoryContainer.getSlot(slot).stack

                if (itemStack != null)
                {
                    // 提前切换物品栏
                    mc.netHandler.addToSendQueue(C09PacketHeldItemChange(slot - 36))
                }
                else
                {
                    ClientUtils.displayChatMessage("错误!#1")
                }
            }
            else
            {
                ClientUtils.displayChatMessage("物品栏里面没有火球！")
            }
        }
    }

    private fun findFireballInHotbar(): Int {
        for (i in 36 until 45) {
            val stack = mc.thePlayer.inventoryContainer.getSlot(i).stack

            if (stack != null && stack.item is ItemFireball)
                return  i
        }

        return -1
    }
    // TODO 全自动 hypixel ping ，获取到最真实的ping可以帮助提升准确度

    private fun tryToCatchFireball(fireball: EntityLargeFireball) {
        val mx = fireball.motionX
        val my = fireball.motionY
        val mz = fireball.motionZ

        val fx = fireball.posX
        val fy = fireball.posY
        val fz = fireball.posZ

        val px = mc.thePlayer.posX
        val py = mc.thePlayer.posY
        val pz = mc.thePlayer.posZ

        if (d(px, py, pz, fx, fy, fz) < d(px, py, pz, fx+mx, fy+my, fz+mz))
        {
            if (!targetFireballThatAreGettingFurtherValue.get())
            {
                return
            }
            else
            {
                ClientUtils.displayChatMessage("检测到一个离我们而去的火球。不予拦截")
            }
        }
        else
        {
            ClientUtils.displayChatMessage("检测到一个奔我们而来的火球")
        }

        //val r = mc.theWorld.rayTraceBlocks(fireball.positionVector, direction)

        //val blockPos = raytrace(fireball.positionVector, direction)

        val dir = Vec3(fireball.motionX , fireball.motionY, fireball.motionZ).normalize()
        val lookVec = Vec3(dir.xCoord * rangeValue.get(), dir.yCoord * rangeValue.get(), dir.zCoord * rangeValue.get()) // TODO changed from 300 to 30000
        val hitBlock = mc.thePlayer.worldObj.rayTraceBlocks(fireball.positionVector, fireball.positionVector.add(lookVec), false, true, false) // TODO 无关的不拦截
        //val blockPos = raytrace(fireball.positionVector, direction)
        if (hitBlock != null)
            if (hitBlock.blockPos.getVec().distanceTo(mc.thePlayer.positionVector) > hitRangeValue.get())
                if (!targetFireballThatAreOutOfHitRangeValue.get())
                {
                    // 不予拦截
                    ClientUtils.displayChatMessage("火球与我们无关，不予拦截")
                    return
                }
                else
                    ClientUtils.displayChatMessage("火球与我们无关，但仍拦截")
            else
            {
                // 予以拦截
                ClientUtils.displayChatMessage("火球会击中方块")
                blockMap[fireball] = hitBlock.blockPos
            }
        else
        {
            ClientUtils.displayChatMessage("火球什么都不会打中")
            if (!targetFireballThatWontHitAnythingValue.get())
                return
        }

        var motionVec = Vec3(fireball.motionX, fireball.motionY, fireball.motionZ)
        val dirVec = motionVec.normalize().multiply(0.1)
        var currentPosVec = fireball.positionVector

        poseses.clear()
        val poses = ArrayList<Vec3>()

        var timeInTicks = 0

        var bestVec: Vec3? = null
        var bestTime = Double.MAX_VALUE

        val time = System.currentTimeMillis()

        val playerEyesPos = mc.thePlayer.eyes
        while (timeInTicks <= second() * 20) {
            if (mc.theWorld.isMaterialInBB(currentPosVec.toAxisAlignedBB(), Material.air))
            {
                if (playerEyesPos.distanceTo(currentPosVec) > rangeValue.get())
                {
                    ClientUtils.displayChatMessage("这个火球在给定的距离内无法拦截")
                    return
                }
                // ---------------------- ANTI-AIR START ---------------------------------------------------------------
                // time for fire ball to get to currentVec
                val timeForFireballToGoInSeconds = timeInTicks / 20.0

                // time for our fireball to get to currentVec
                val pingInSeconds = ServerPing.ping / 1000.0
                    //mc.netHandler.getPlayerInfo(mc.thePlayer.uniqueID).responseTime / 1000.0
                // add a TICK because aiming takes 1 TICK before we launch
                val timePlayerToTarget =
                    (pingInSeconds) + (delayValue.get() / 1000.0) + (getTimeInTicks(currentPosVec) / 20.0) + TICK + (System.currentTimeMillis() - time) / 1000.0 // TODO 重新计算加几个刻

                // TODO use motion event. pre/post (真的需要吗?)
                //ClientUtils.displayChatMessage("remote: $timeForFireballToGoInSeconds, ours: $timePlayerToTarget(ping: $pingInSeconds, delay: ${delayValue.get() / 1000.0}, ticks: ${timeInTicks(currentPosVec) / 20.0})")

                val currentTimeDiff = abs(timePlayerToTarget - timeForFireballToGoInSeconds)
                if (currentTimeDiff < bestTime) {
                    bestTime = currentTimeDiff
                    bestVec = currentPosVec
                }

                if (currentTimeDiff > bestTime) // 不能改为 =， 因为一开始都是INFINITE，是相等的，会直接break，导致直接打头
                {
                    // 时间差已经开始增大了，说明已经找到近似解
                    break
                }
            }
            else
            {
                // 在时间差开始增大前碰到方块，意味着这个火球不在我们能拦截的范围内(在拦截火球到达前它就会碰到方块)
                ClientUtils.displayChatMessage("这个火球无法拦截，在拦截火球到达前它就会碰到方块")
                return
            }

            // ---------------------- ANTI-AIR END -----------------------------------------------------------------

            // -------------------------------------- MOVE PREDICT START--------------------------------------------
            // record time for current vec
            //vecToTimeMap[currentPosVec] = timeInTick++ // No longer need
            // move current vec to next tick
            currentPosVec = currentPosVec.add(motionVec)
            motionVec = motionVec.add(dirVec)
            val isInWater = false //mc.theWorld.isMaterialInBB(currentPosVec.toAxisAlignedBB(), Material.water) // TODO support when performance is good
            motionVec = motionVec.multiply(if (isInWater) 0.8 else 0.95)
            // ------------------------------------ MOVE PREDICT END -----------------------------------------------

            timeInTicks++

            // TODO 移动会导致无法拦截 => target 计算时采用玩家实时位置
        }

        // !!!!!
        if (mc.netHandler.networkManager.channel().remoteAddress().toString().contains("127.0.0.1"))
            mc.thePlayer.sendChatMessage("Time spend: ${(System.currentTimeMillis() - time) / 50.0} tick")

        poseses[fireball] = poses

        catchVec = bestVec?.add(Vec3(0.0, yOffsetValue.get().toDouble(), 0.0))
        toBeAnti = fireball

        // !!! 请确保到达这一步的火球是可以被拦截的
        doStep1 = true

        // TODO 考虑自动将延迟算入时间内
        // TODO 为什么射一次之后就不射了
        // TODO 完善不拦截机制（调试时就不用了）
        // TODO 速度拟合误差太大，考虑构建模型，对每一个位移有唯一的时间对应，即每一tick对应原版计算获得，绝对精确 （现有问题：从远处射达到最高速度后即使贴脸也无法拦截 ） （发现问题：如果发射时火球尚未加载出来？）
        // TODO 敌对玩家火球跳检测（poses最远点距离过于短则不拦截）
        // TODO 控制火球撞击后方向：尽量向下，故将撞击点略微上移，或能控制最好（撞向敌对玩家，会很难，两个火球中会有一个爆炸）
    }

    @EventTarget
    fun onRender3D(event: Render3DEvent) {
        for (pos in blockMap.values)
        {
            RenderUtils.drawBlockBox(pos, Color.RED, true)
        }

        if (catchVec != null && !doStep1)
        {
            RenderUtils.drawBlockBox(BlockPos(catchVec), Color.ORANGE, true)
        }
    }

    private fun d(x: Double, y: Double, z:Double, x1: Double, y1: Double, z1:Double): Double =
        sqrt((x - x1) * (x - x1) + (y - y1) * (y - y1) + (z - z1) * (z - z1))

    private fun getTimeInTicks(target: Vec3): Int {
        var motionVec = Vec3(0.0, 0.0, 0.0)
        val dirVec = target.subtract(mc.thePlayer.eyes).normalize().multiply(0.1)
        var currentPosVec = mc.thePlayer.eyes

        var timeInTick = 0
        val maxTicks = second() * 20 // = ticks = seconds * 20

        var distance = Double.MAX_VALUE
        var distancePrev: Double

        var bestDistance = Double.MAX_VALUE
        var bestTimeInTick = Int.MAX_VALUE

        while (timeInTick <= maxTicks)
        {
            distancePrev = distance
            distance = currentPosVec.distanceTo(target)

            if (distance < bestDistance)
            {
                bestDistance = distance
                bestTimeInTick = timeInTick
            }

            if (distance != Double.MAX_VALUE && distancePrev != Double.MAX_VALUE)
            {
                if (distance > distancePrev)
                {
                    return timeInTick - 1
                }
            }

            // -------------------------------------- MOVE START -----------------------------------------------------
            currentPosVec = currentPosVec.add(motionVec)
            motionVec = motionVec.add(dirVec)
            val isInWater = false // mc.theWorld.isMaterialInBB(currentPosVec.toAxisAlignedBB(), Material.water)
            motionVec = motionVec.multiply(if (isInWater) 0.8 else 0.95)
            // -------------------------------------- MOVE END -------------------------------------------------------

            timeInTick++
        }

        return bestTimeInTick
    }
}